> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/extension-dev.md).

# Extensions Developement

This section covers developement of extensions that can be added to the Servoy core product.

There are 2 main area's of developement 1 is the [Components And Services](/reference/extension-dev/component_services.md) and the other is server side [Java Plugin](/reference/extension-dev/serverside.md) development.

Component and Services are executed in the browser and build with Angular written in Typescript. The api is declared in the [spec](/reference/extension-dev/component_services/spec-file.md) and exposed in in Servoy scripting api through elements.xxx (components) or through the "plugins." node (services)

Server side plugins are written in Java and do run server side in the client that can be accessed through the exposed api on the "plugins." node.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.servoy.com/reference/extension-dev.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
